import { SheetJSInternalUtils } from '../../../../utils/outerTableComponents/files/SheetJS/SheetJSInternalUtils';
import { SheetJSExport } from '../../../../utils/outerTableComponents/files/SheetJS/SheetJSExport';
import { CSVExport } from '../../../../utils/outerTableComponents/files/CSV/CSVExport';
import { ACCEPTED_FILE_FORMATS } from '../../../../consts/fileFormats';
export class FileExportButtonEvents {
    static export(at, options) {
        const acceptedFormat = (options === null || options === void 0 ? void 0 : options.format) || 'csv';
        if (ACCEPTED_FILE_FORMATS.find((extension) => acceptedFormat === extension)) {
            const fileName = options === null || options === void 0 ? void 0 : options.fileName;
            if (acceptedFormat === 'csv') {
                CSVExport.export(at, fileName);
            }
            else {
                SheetJSInternalUtils.execFuncWithExtractorModule(SheetJSExport.export.bind(this, at, acceptedFormat, fileName));
            }
        }
    }
    static setEvents(at, buttonElement, options) {
        buttonElement.onclick = FileExportButtonEvents.export.bind(this, at, options);
    }
}
//# sourceMappingURL=fileExportButtonEvents.js.map