import { OuterContainerElements } from '../../../utils/outerTableComponents/outerContainerElements';
import { FilesUtils } from '../../../utils/outerTableComponents/files/filesInternalUtils';
import { FileImportButtonEvents } from './importButton/fileImportButtonEvents';
import { FileExportButtonEvents } from './exportButton/fileExportButtonEvents';
import { StatefulCSSEvents } from '../../../utils/elements/statefulCSSEvents';
export class FileButtonElements {
    static setEvents(at, button, buttonElement) {
        if (button.import) {
            FileImportButtonEvents.setEvents(at, buttonElement, typeof button.import === 'object' ? button.import : undefined);
        }
        else if (button.export) {
            FileExportButtonEvents.setEvents(at, buttonElement, typeof button.export === 'object' ? button.export : undefined);
        }
    }
    static createElement(buttonProps, defaultText) {
        const { text, order, styles } = buttonProps;
        const buttonElement = document.createElement('div');
        buttonElement.classList.add(FileButtonElements.BUTTON_CLASS);
        buttonElement.textContent = text || defaultText;
        buttonElement.style.order = String(order || 0);
        const processedStyles = FilesUtils.processStyles(styles);
        Object.assign(buttonElement.style, processedStyles.default);
        setTimeout(() => StatefulCSSEvents.setEvents(buttonElement, processedStyles));
        return buttonElement;
    }
    static create(at, outerContainers) {
        var _a, _b;
        (_b = (_a = at.files) === null || _a === void 0 ? void 0 : _a.buttons) === null || _b === void 0 ? void 0 : _b.forEach((button) => {
            if (!button.export && !button.import)
                return;
            const buttonElement = FileButtonElements.createElement(button, button.import ? 'Import' : 'Export');
            const position = button.position || FilesUtils.DEFAULT_BUTTON_POSITION;
            OuterContainerElements.addToContainer(position, outerContainers, buttonElement);
            setTimeout(() => FileButtonElements.setEvents(at, button, buttonElement));
        });
    }
}
FileButtonElements.BUTTON_CLASS = 'file-button';
//# sourceMappingURL=fileButtonElements.js.map