import { OuterDropdownElement } from '../../../../utils/outerTableComponents/dropdown/outerDropdownElement';
import { OuterDropdownItem } from '../../../../utils/outerTableComponents/dropdown/outerDropdownItem';
import { RowsPerPageDropdownItem } from './rowsPerPageDropdownItem';
export class RowsPerPageDropdown {
    static hide(activeOverlayElements, dropdownItems) {
        var _a;
        OuterDropdownElement.hide(activeOverlayElements, {});
        const dropdownElement = (_a = activeOverlayElements.outerContainerDropdown) === null || _a === void 0 ? void 0 : _a.element;
        if (dropdownElement) {
            const items = dropdownItems || Array.from(dropdownElement.children);
            OuterDropdownItem.unsetHoverColors(items);
        }
    }
    static getDropdownTopPosition(buttonElement) {
        return `${buttonElement.offsetTop + buttonElement.offsetHeight}px`;
    }
    static getLeftPropertyToCenterDropdown(buttonElement, dropdownWidth) {
        const leftOffset = buttonElement.offsetLeft + buttonElement.offsetWidth / 2;
        return `${leftOffset - dropdownWidth / 2}px`;
    }
    // prettier-ignore
    static display(buttonElement, at, dropdown) {
        const { _pagination: { dropdownWidth } } = at;
        const { element: dropdownElement } = dropdown;
        dropdownElement.style.bottom = '';
        dropdownElement.style.left = RowsPerPageDropdown.getLeftPropertyToCenterDropdown(buttonElement, dropdownWidth);
        dropdownElement.style.top = RowsPerPageDropdown.getDropdownTopPosition(buttonElement);
        // needs to be displayed here to evalute if in view port
        OuterDropdownElement.displayReactToBottomVisibility(at, dropdown);
    }
    static setWidth(dropdownElement, pagination) {
        const maxTextCharLength = pagination.rowsPerPageOptionsItemText.reduce((currrentMax, value) => {
            return isNaN(Number(value)) ? currrentMax : Math.max(currrentMax, value.length);
        }, 1);
        const textLength = maxTextCharLength * 8;
        pagination.dropdownWidth = pagination.dropdownWidth + textLength;
        dropdownElement.style.width = `${pagination.dropdownWidth}px`;
    }
    static create(at, optionsButton) {
        const hideFunc = RowsPerPageDropdown.hide.bind(this, at._activeOverlayElements);
        const displayFunc = RowsPerPageDropdown.display.bind(this, optionsButton);
        // position is arbitrary as long as orientation isn't changed
        const dropdown = OuterDropdownElement.create(at, optionsButton, 'bottom-middle', {}, [], hideFunc, displayFunc);
        RowsPerPageDropdownItem.populate(at, dropdown.element, optionsButton);
        RowsPerPageDropdown.setWidth(dropdown.element, at._pagination);
        return dropdown;
    }
}
//# sourceMappingURL=rowsPerPageDropdown.js.map