import { TableDimensionsUtils } from '../../../../utils/tableDimensions/tableDimensionsUtils';
import { AddNewRowElement } from '../row/addNewRowElement';
// REF-18
export class NoContentStubElement {
    static convertFromStub(event) {
        const addNewRowCell = event.target;
        addNewRowCell.classList.remove(NoContentStubElement.NO_CONTENT_STUB_CLASS);
        AddNewRowElement.setDefaultStyle(addNewRowCell);
        addNewRowCell.removeEventListener('click', NoContentStubElement.convertFromStub);
    }
    static convertToStub(addNewRowCell) {
        addNewRowCell.classList.add(NoContentStubElement.NO_CONTENT_STUB_CLASS);
        addNewRowCell.innerText = '+';
        addNewRowCell.style.width = `${TableDimensionsUtils.MINIMAL_TABLE_WIDTH}px`;
    }
    // addNewRowCell is preserved as it is reused as the stub element
    static removeRows(tableBodyElement) {
        Array.from(tableBodyElement.children)
            .slice(0, tableBodyElement.children.length - 1)
            .forEach((rowElement) => rowElement.remove());
    }
    // prettier-ignore
    static display(at) {
        const { _tableBodyElementRef, _addColumnCellsElementsRef, _addRowCellElementRef, _frameComponents: { displayAddNewColumn, displayAddNewRow } } = at;
        if (!_addRowCellElementRef)
            return;
        const tableBodyElement = _tableBodyElementRef;
        if (displayAddNewColumn)
            _addColumnCellsElementsRef.splice(0, _addColumnCellsElementsRef.length);
        NoContentStubElement.removeRows(tableBodyElement);
        if (displayAddNewRow) {
            NoContentStubElement.convertToStub(_addRowCellElementRef);
            _addRowCellElementRef.addEventListener('click', NoContentStubElement.convertFromStub);
        }
        AddNewRowElement.setDisplay(_addRowCellElementRef, true);
    }
}
NoContentStubElement.NO_CONTENT_STUB_CLASS = 'no-content-stub';
//# sourceMappingURL=noContentStubElement.js.map