import { AddNewRowElement } from '../../elements/table/addNewElements/row/addNewRowElement';
import { CellHighlightUtils } from '../color/cellHighlightUtils';
import { ElementStyle } from '../elements/elementStyle';
export class RowHoverEvents {
    static mouseLeaveRow(rowElement, style, defaultStyle) {
        ElementStyle.unsetStyle(rowElement, style);
        Object.assign(rowElement.style, defaultStyle);
    }
    static mouseEnterRow(rowElement, style) {
        Object.assign(rowElement.style, style);
    }
    static canStyleBeApplied(rowHoverStyles, rowElement, rowIndex) {
        return ((rowHoverStyles === null || rowHoverStyles === void 0 ? void 0 : rowHoverStyles.style) &&
            (rowIndex > 0 || rowHoverStyles.header) &&
            (!AddNewRowElement.isAddNewRowRow(rowElement) || rowHoverStyles.addNewRowButton));
    }
    // prettier-ignore
    static addEvents(rowHoverStyles, rowElement, rowIndex, defaultStyle) {
        if (RowHoverEvents.canStyleBeApplied(rowHoverStyles, rowElement, rowIndex)) {
            rowElement.onmouseenter = RowHoverEvents.mouseEnterRow.bind(this, rowElement, rowHoverStyles.style);
            rowElement.onmouseleave = RowHoverEvents.mouseLeaveRow.bind(this, rowElement, rowHoverStyles.style, defaultStyle);
        }
    }
    static process(rowHoverStyles, defaultCellHoverColors) {
        var _a, _b;
        if (rowHoverStyles === null || rowHoverStyles === void 0 ? void 0 : rowHoverStyles.style) {
            (_a = rowHoverStyles.header) !== null && _a !== void 0 ? _a : (rowHoverStyles.header = true);
            (_b = rowHoverStyles.addNewRowButton) !== null && _b !== void 0 ? _b : (rowHoverStyles.addNewRowButton = true);
            CellHighlightUtils.unsetDefaultHoverProperties(defaultCellHoverColors);
        }
    }
}
//# sourceMappingURL=rowHoverEvents.js.map